/***************************************************************************
 *
 * Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: satyr.h,v 1.4 2000/08/14 14:58:10 bazsi Exp $
 *
 ***************************************************************************/


#ifndef ZORP_SATYR_H_INCLUDED
#define ZORP_SATYR_H_INCLUDED

#include <glib.h>

#include <zorp/authconn.h>
#include <zorp/labelset.h>
#include <zorp/sockaddr.h>

typedef struct _ZSatyrAuthenticator ZSatyrAuthenticator;

#define Z_SATYR_TYPE_UDP    1
#define Z_SATYR_TYPE_TCP    2

typedef struct _ZSatyrSubjID
{
//      guint auth_type;
//      guint ref_count;
  ZSockAddr *addr;       /* address of client */
  guint type;		 /* TCP or UDP */
} ZSatyrSubjID;

ZSatyrAuthenticator *z_satyr_authenticator_new(ZAuthConnection * auth_conn);

void z_satyr_authenticator_ref(ZSatyrAuthenticator * self);

void z_satyr_authenticator_unref(ZSatyrAuthenticator * self);

ZLabelSet *z_satyr_authenticator_auth(ZSatyrAuthenticator * self,
				      ZSatyrSubjID * subj,
				      int satyr_port,
				      char *object_descr, 
				      char **methods);

#endif /* SATYR_H */
