/***************************************************************************
 *
 * Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: anypy.c,v 1.6 2000/08/16 13:32:34 bazsi Exp $
 *
 ***************************************************************************/
 
#include <zorp/zorp.h>
#include <zorp/proxy.h>
#include <zorp/thread.h>
#include <zorp/policy.h>
#include <zorp/zpython.h>
#include <zorp/pystream.h>

typedef struct _ZAnyPyProxy
{
  ZProxy super;
  PyThreadState *tstate;
  ZPolicyObj *client, *server;
} ZAnyPyProxy;

static void
anypy_thread(gpointer s)
{
  ZAnyPyProxy *self = (ZAnyPyProxy *) s;
  
  self->tstate = PyThreadState_New(z_python_global_state->interp);
  PyEval_AcquireThread(self->tstate);
  
  z_policy_call(self->super.handler, "proxyThread", NULL);
  
  PyEval_ReleaseThread(self->tstate);
  PyEval_AcquireThread(z_python_global_state);
  PyThreadState_Clear(self->tstate);
  PyEval_ReleaseThread(z_python_global_state);
  z_proxy_destroy(&self->super);
}

ZProxy *
anypy_proxy_new(gchar *session_id,
		ZorpStream *client, 
                ZPolicyObj *handler)
{
  ZAnyPyProxy *self = g_new0(ZAnyPyProxy, 1);
  char buf[128];
  
  z_proxy_init(&self->super, session_id, client->stream, handler);
  self->client = (PyObject *) client;
  z_policy_var_ref(client);
  
  snprintf(buf, sizeof(buf), "anypy thread (%s)", client->stream->name);
  z_thread_new(buf, anypy_thread, self);
  return &self->super;
}
