/***************************************************************************
 *
 * Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: ftp.h,v 1.10 2000/08/08 14:39:00 bazsi Exp $
 *
 * Author:  Andras Kis-Szabo <kisza@sch.bme.hu>
 * Auditor:
 * Notes:
 *
 ***************************************************************************/

#ifndef __FTP_H
#define __FTP_H

#define KNOWN_COMMANDS             62
#define MAX_LEN			   2048

#define PARSE_SERVER_BEGIN          0
#define PARSE_SERVER_INNER          1
#define PARSE_RETURN                9

//
// FTP statemachine states
// 
#define FTP_STATE_CONNECT           0
#define FTP_STATE_LOGIN             1
#define FTP_STATE_LOGIN_U           11
#define FTP_STATE_LOGIN_P           12
#define FTP_STATE_LOGIN_A           13
#define FTP_STATE_PRECONNECT        2
#define FTP_STATE_LOGINAUTH         3
#define FTP_STATE_CONVERSATION      4
#define FTP_STATE_QUIT              5
#define FTP_STATE_RETURN            9

#define FTP_INITIAL                 0
#define FTP_SERVER_TO_CLIENT        1
#define FTP_CLIENT_TO_SERVER        2
#define FTP_MAIN_RET                8
#define FTP_EXIT                    9

//
// LOG-flags
// 
#define LOG_COMM             1
#define LOG_ANSW             2
#define LOG_UNKN             4
#define LOG_DROP             8
#define LOG_PASS            16
#define LOG_PROX            32

//
// Command groups
// 
#define flag_rfc_1545		(0x80000000L)
#define flag_rfc_2228		(0x40000000L)
#define flag_rfc_1579		(0x20000000L)
#define flag_rfc_2389		(0x10000000L)
#define flag_rfc_2428		(0x08000000L)
#define flag_rfc_765		(0x04000000L)
#define flag_rfc_775		(0x02000000L)
#define flag_rfc_959		(0x01000000L)
#define flag_level_connect	(0x00800000L)
#define flag_level_login	(0x00400000L)
#define flag_level_dataprot	(0x00200000L)
#define flag_level_commandc	(0x00100000L)
#define flag_level_logoff	(0x00080000L)
#define flag_level_transpar	(0x00040000L)
#define flag_level_inform	(0x00020000L)
#define flag_level_misc		(0x00010000L)
#define flag_level_directory	(0x00008000L)
#define flag_level_fileact	(0x00004000L)
#define flag_level_mail 	(0x00002000L)
#define flag_level_unknown	(0x00001000L)
#define flag_access_read	(0x00000800L)
#define flag_access_write	(0x00000400L)
#define flag_access_ctrlsys	(0x00000200L)
#define flag_access_ctrlnet	(0x00000100L)
#define flag_access_unkn	(0x00000080L)
#define flag_name_known  	(0x00000040L)
#define flag_name_unknown   	(0x00000020L)
#define flag_name_reset  	(0x00000010L)
#define flag_cc_read 		(0x00000008L)
#define flag_cc_write 	  	(0x00000004L)
#define flag_cc_controll   	(0x00000002L)
#define flag_cc_feedback  	(0x00000001L)

/*
 * HASH flags
 */
#define active_flag_ABOR	( flag_rfc_959 | flag_level_misc | flag_access_ctrlsys | flag_name_unknown | flag_cc_controll )
#define active_flag_ACCT	( flag_rfc_959 | flag_level_login | flag_access_ctrlsys | flag_name_known | flag_cc_controll )
#define active_flag_ADAT	( flag_rfc_2228 | flag_level_connect | flag_access_ctrlsys | flag_name_known | flag_cc_controll )
#define active_flag_ALLO	( flag_rfc_959 | flag_level_fileact | flag_access_ctrlsys | flag_name_unknown | flag_cc_controll )
#define active_flag_APPE	( flag_rfc_959 | flag_level_fileact | flag_access_write | flag_name_unknown | flag_cc_write )
#define active_flag_APSV	( flag_rfc_1579 | flag_level_transpar | flag_access_ctrlnet | flag_name_unknown | flag_cc_controll )
#define active_flag_AUTH	( flag_rfc_2228 | flag_level_connect | flag_access_ctrlsys | flag_name_known | flag_cc_controll )
#define active_flag_CCC 	( flag_rfc_2228 | flag_level_commandc | flag_access_ctrlsys | flag_name_unknown | flag_cc_controll )
#define active_flag_CDUP	( flag_rfc_959 | flag_level_directory | flag_access_read | flag_name_unknown | flag_cc_controll )
#define active_flag_CONF	( flag_rfc_2228 | flag_level_commandc | flag_access_ctrlsys | flag_name_unknown | flag_cc_controll )
#define active_flag_CWD 	( flag_rfc_959 | flag_level_directory | flag_access_read | flag_name_unknown | flag_cc_controll )
#define active_flag_DELE	( flag_rfc_959 | flag_level_fileact | flag_access_write | flag_name_unknown | flag_cc_controll )
#define active_flag_ENC 	( flag_rfc_2228 | flag_level_commandc | flag_access_write | flag_name_known | flag_cc_write )
#define active_flag_EPRT	( flag_rfc_2428 | flag_level_transpar | flag_access_ctrlnet | flag_name_unknown | flag_cc_controll )
#define active_flag_EPSV	( flag_rfc_2428 | flag_level_transpar | flag_access_ctrlnet | flag_name_unknown | flag_cc_controll )
#define active_flag_FEAT	( flag_rfc_2389 | flag_level_inform | flag_access_ctrlsys | flag_name_unknown | flag_cc_controll )
#define active_flag_HELP	( flag_rfc_959 | flag_level_inform | flag_access_ctrlsys | flag_name_unknown | flag_cc_controll )
#define active_flag_LIST	( flag_rfc_959 | flag_level_fileact | flag_access_read | flag_name_unknown | flag_cc_controll )
#define active_flag_LPRT	( flag_rfc_1545 | flag_level_transpar | flag_access_ctrlnet | flag_name_unknown | flag_cc_controll )
#define active_flag_LPSV	( flag_rfc_1545 | flag_level_transpar | flag_access_ctrlnet | flag_name_unknown | flag_cc_controll )
#define active_flag_MAIL	( flag_rfc_765 | flag_level_mail | flag_access_write | flag_name_unknown | flag_cc_controll )
#define active_flag_MDTM	( flag_level_unknown | flag_access_unkn | flag_name_unknown | flag_cc_controll )
#define active_flag_MIC		( flag_rfc_2228 | flag_level_commandc | flag_access_ctrlsys | flag_name_unknown | flag_cc_controll )
#define active_flag_MKD 	( flag_rfc_959 | flag_level_directory | flag_access_write | flag_name_unknown | flag_cc_write )
#define active_flag_MLFL	( flag_rfc_765 | flag_level_fileact | flag_access_read | flag_name_unknown | flag_cc_controll )
#define active_flag_MODE	( flag_rfc_959 | flag_level_transpar | flag_access_ctrlsys | flag_name_unknown | flag_cc_controll )
#define active_flag_MRCP	( flag_rfc_765 | flag_level_mail | flag_access_ctrlsys | flag_name_unknown | flag_cc_controll )
#define active_flag_MRSQ	( flag_rfc_765 | flag_level_mail | flag_access_write | flag_name_unknown | flag_cc_controll )
#define active_flag_MSAM	( flag_rfc_765 | flag_level_mail | flag_access_write | flag_name_unknown | flag_cc_controll )
#define active_flag_MSND	( flag_rfc_765 | flag_level_mail | flag_access_write | flag_name_unknown | flag_cc_controll )
#define active_flag_MSOM	( flag_rfc_765 | flag_level_mail | flag_access_write | flag_name_unknown | flag_cc_controll )
#define active_flag_NLST	( flag_rfc_959 | flag_level_fileact | flag_access_read | flag_name_unknown | flag_cc_controll )
#define active_flag_NOOP	( flag_rfc_959 | flag_level_misc | flag_access_ctrlsys | flag_name_unknown | flag_cc_controll )
#define active_flag_OPTS	( flag_rfc_2389 | flag_level_inform | flag_access_ctrlsys | flag_name_unknown | flag_cc_controll )
#define active_flag_PASS	( flag_rfc_959 | flag_level_login | flag_access_ctrlsys | flag_name_known | flag_cc_controll )
#define active_flag_PASV	( flag_rfc_959 | flag_level_transpar | flag_access_ctrlnet | flag_name_unknown | flag_cc_controll )
#define active_flag_PBSZ	( flag_rfc_2228 | flag_level_commandc | flag_access_ctrlnet | flag_name_reset | flag_cc_controll )
#define active_flag_PORT	( flag_rfc_959 | flag_level_transpar | flag_access_ctrlnet | flag_name_unknown | flag_cc_controll )
#define active_flag_PROT	( flag_rfc_2228 | flag_level_dataprot | flag_access_ctrlsys | flag_name_unknown | flag_cc_controll )
#define active_flag_PWD 	( flag_rfc_959 | flag_level_directory | flag_access_read | flag_name_unknown | flag_cc_controll )
#define active_flag_QUIT	( flag_rfc_959 | flag_level_logoff | flag_access_ctrlsys | flag_name_reset | flag_cc_controll )
#define active_flag_REIN	( flag_rfc_959 | flag_level_logoff | flag_access_ctrlsys | flag_name_reset | flag_cc_controll )
#define active_flag_REST	( flag_rfc_959 | flag_level_fileact | flag_access_ctrlsys | flag_name_unknown | flag_cc_read )
#define active_flag_RETR	( flag_rfc_959 | flag_level_fileact | flag_access_read | flag_name_unknown | flag_cc_read )
#define active_flag_RMD 	( flag_rfc_959 | flag_level_directory | flag_access_write | flag_name_unknown | flag_cc_write )
#define active_flag_RNFR	( flag_rfc_959 | flag_level_fileact | flag_access_write | flag_name_unknown | flag_cc_write )
#define active_flag_RNTO	( flag_rfc_959 | flag_level_fileact | flag_access_write | flag_name_unknown | flag_cc_write )
#define active_flag_SITE	( flag_rfc_959 | flag_level_misc | flag_access_unkn | flag_name_unknown | flag_cc_controll )
#define active_flag_SIZE	( flag_rfc_959 | flag_level_fileact | flag_access_read | flag_name_unknown | flag_cc_controll )
#define active_flag_SMNT	( flag_rfc_959 | flag_level_directory | flag_access_read | flag_name_unknown | flag_cc_controll )
#define active_flag_STAT	( flag_rfc_959 | flag_level_inform | flag_access_read | flag_name_unknown | flag_cc_controll )
#define active_flag_STOR	( flag_rfc_959 | flag_level_fileact | flag_access_write | flag_name_unknown | flag_cc_write )
#define active_flag_STOU	( flag_rfc_959 | flag_level_fileact | flag_access_write | flag_name_unknown | flag_cc_write )
#define active_flag_STRU	( flag_rfc_959 | flag_level_transpar | flag_access_ctrlsys | flag_name_unknown | flag_cc_write )
#define active_flag_SYST	( flag_rfc_959 | flag_level_misc | flag_access_ctrlsys | flag_name_unknown | flag_cc_controll )
#define active_flag_TYPE	( flag_rfc_959 | flag_level_transpar | flag_access_ctrlsys | flag_name_unknown | flag_cc_controll )
#define active_flag_USER	( flag_rfc_959 | flag_level_login | flag_access_ctrlsys | flag_name_known | flag_cc_controll )
#define active_flag_XCUP	( flag_rfc_775 | flag_level_directory | flag_access_read | flag_name_unknown | flag_cc_controll )
#define active_flag_XCWD	( flag_rfc_775 | flag_level_directory | flag_access_read | flag_name_unknown | flag_cc_controll )
#define active_flag_XMKD	( flag_rfc_775 | flag_level_directory | flag_access_write | flag_name_unknown | flag_cc_write )
#define active_flag_XPWD	( flag_rfc_775 | flag_level_directory | flag_access_read | flag_name_unknown | flag_cc_controll )
#define active_flag_XRMD	( flag_rfc_775 | flag_level_directory | flag_access_write | flag_name_unknown | flag_cc_write )


typedef struct _FtpProxy
{
  ZProxy super;
  gboolean quit;
  //ZPoll *poll;
  ZReadLine *readline[EP_MAX];
  gboolean proxy_state;
  //guint client_active;
  //guint client_passive;
  guint client_portpasv;
  guint last_port;
  guint tmp_port;
  guint NAT;
  guint internal_server;
  gboolean verbose_messages;
  gboolean bounce_check;
  guint max_line_length;
  guint max_username_length;
  guint max_password_length;
  guint max_pathname_length;
  gchar *username;
  gchar *password;
  GString * client_data_address;
  GString * server_data_address;
  GString * fw_internal_data_address;
  GString * fw_external_data_address;
  GString * tmp_data_address;
  guint client_data_port;
  guint server_data_port;
  guint fw_internal_data_port;
  guint fw_external_data_port;
  guint tmp_data_port;
  guint tmp2_data_port;
  gchar command[5];
  gchar *parameter;
  gchar *path;
  gchar path_separator;
  guint allow_PWD;
  gchar check_addr[16];
  unsigned long command_accept;
  unsigned long command_log;
  unsigned long command_up;
  guint command_unk;
  gboolean log_dropped;
  gboolean log_answer;

  gboolean server_answer_begin;
  gchar answer_code[3];
  int ftp_state;

  int state;

  unsigned long sent_C2P;
  unsigned long sent_P2C;
  unsigned long sent_S2P;
  unsigned long sent_P2S;

  GHashTable *local_command;
  GHashTable *local_answer;

}
FtpProxy;

typedef struct _FTPInternalCommand
{
  char *info;
  int number;
}
FTPInternalCommand;

typedef struct _FTPAnswerDescriptor
{
  char *info;
  int number;
  // 2 - ftp state information
  // 3 - answer code
  // 4 - command
  // 1 - '\0'
}
FTPAnswerDescriptor;

typedef struct _FTPCommandDescriptor
{
  char *name;
  unsigned long flag;
  int number;
  gpointer fv;
  char *event;
  int need_data;
}
FTPCommandDescriptor;


//extern static void ftp_proxy_free (ZProxy *);

typedef int (*ftp_hash_fv) (FtpProxy *, char *, int, FTPCommandDescriptor *);


#define MSG_CANT_PORT			(0)
#define MSG_NO_REIN			(1)
#define MSG_COMMAND_DISABLED_500	(2)
#define MSG_BAD_PASSFORM		(3)
#define MSG_USERPASS_FIRST		(4)
#define MSG_USER_FIRST			(5)
#define MSG_USER_ALREADY		(6)
#define MSG_NO_USER_ACCESS		(7)
#define MSG_BAD_USERF			(8)
#define MSG_BAD_ALLO			(9)

#define MSG_BAD_PATH_FORMAT		(10)
#define MSG_MARKER_INVALID		(11)
#define MSG_ARG_INVALID			(12)
#define MSG_COMMAND_DISABLED		(13)
#define MSG_TOO_MANY_PARAM		(14)
#define MSG_CANT_TYPE			(15)
#define MSG_TYPE_BYTE_SIZE		(16)
#define MSG_TYPE_FORM			(17)
#define MSG_TYPE_E			(18)
#define MSG_INVALID_STRU		(19)

#define MSG_UNIMPLEMENTED_STRU		(20)
#define MSG_INVALID_MODE		(21)
#define MSG_UNIMPLEMENTED_MODE		(22)
#define MSG_WELCOME			(23)
#define MSG_TERM_CRLF			(24)
#define MSG_LINE_LONG			(25)
#define MSG_SYNTAX			(26)
#define MSG_Z_ABORT			(27)
#define MSG_SERVER_BOUNCE		(28)
#define MSG_PORT_SUCCESS		(29)

extern char *msgs[];
extern GHashTable *ftp_answer_hash;
extern GHashTable *ftp_command_hash;


#endif
