/***************************************************************************
 *
 * Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: httpstr.h,v 1.10 2000/09/25 12:11:25 bazsi Exp $
 *
 * By: Kovacs Viktor Peter (vps__@hotmail.com | vps__@freemail.hu | ...)
 *
 ***************************************************************************/

//#define TRUE       (1)
//#define FALSE      (0)

typedef struct _HttpStr{
 char* str;
 int len;
 int alen;
}HttpStr;

void  http_str_init(HttpStr* s);
void  http_str_free(HttpStr* s);

void  http_str_set(HttpStr* s, HttpStr* ns);
void  http_str_sets(HttpStr* s, char* ns);
void  http_str_add(HttpStr* s, HttpStr* ns);
void  http_str_adds(HttpStr* s, char* ns);
void  http_str_addc(HttpStr* s, char ns);
int   http_str_len(HttpStr* s);
char* http_str_str(HttpStr* s);
void  http_str_copyn(HttpStr* s, HttpStr* ns, int len);

void  http_str_allocfill(HttpStr* s, int nlen, char fill);
void  http_str_truncate(HttpStr* s, int nlen);
int   http_str_contains_c(HttpStr* s, char c);                      //-1 = not found

int   http_str_cmpi  (HttpStr* a,   HttpStr* b);                    //terminators: 0x00 0x0A 0x0D len => TRUE/FALSE
int   http_str_ncmpi (HttpStr* a,   HttpStr* b, int len);
int   http_str_cmpis (HttpStr* a,   char* b);                       //terminators: 0x00 0x0A 0x0D len
int   http_str_ncmpis(HttpStr* a,   char* b, int len);

char  http_str_ucase(char c);
