/***************************************************************************
 *
 * Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: httptool.c,v 1.9 2000/09/25 12:11:25 bazsi Exp $
 *
 * By: Kovacs Viktor Peter (vps__@hotmail.com | vps__@freemail.hu | ...)
 *
 ***************************************************************************/
#include "httpstr.h"

#define TRUE  (1)
#define FALSE (0)

int http_check_url(HttpStr* s) //checks correct escapeness
{
 int t=0;

 while(t < (s->len))
 {
  switch((s->str)[t])
  {
   case '%':
    if((t+2) >= (s->len)) return(FALSE);
    t++;
    if(!((((s->str)[t]>='0') && ((s->str)[t]<='9')) ||
         (((s->str)[t]>='a') && ((s->str)[t]<='f')) ||
         (((s->str)[t]>='A') && ((s->str)[t]<='F')) )) return(FALSE);
    t++;
    if(!((((s->str)[t]>='0') && ((s->str)[t]<='9')) ||
         (((s->str)[t]>='a') && ((s->str)[t]<='f')) ||
         (((s->str)[t]>='A') && ((s->str)[t]<='F')) )) return(FALSE);
    break;
   default:
    break;
  }
 t++;
 }
 return(TRUE);
}

int http_check(HttpStr* s)
{
 int t=0;
 for(t=0;t<(s->len);t++)
 {
  if(((s->str)[t])<32) return(FALSE);
 }
 return(TRUE);
}

int http_splitreq(HttpStr* src, HttpStr* cmd, HttpStr* addr, HttpStr* url, HttpStr* ver, HttpStr* userpass)
{
 int t=0;
 int c;
 int addrflg=FALSE;
 int ta,tb;

 http_str_sets(cmd,""); http_str_sets(addr,""); http_str_sets(url,""); http_str_sets(ver,""); http_str_sets(userpass,"");
 if(src->len==0) return(FALSE);
// if(http_check(src)==FALSE) return(FALSE);

 c=(src->str)[0];
 while(c!=0 && c==' '){c=((src->str)[t++]);} //skip space
 if(c==0) return(FALSE);   //empty...

 c=((src->str)[t++]);
 while(c!=0 && c!=' ')     //copy to ' ' or 0 => command
 {
  http_str_addc(cmd, c);
  c=((src->str)[t++]);
 }
// if(c==0) return(FALSE);   //no url...

 while(c!=0 && c==' '){c=((src->str)[t++]);} //skip space
// if(c==0) return(FALSE);   //no url...

 while(c!=0 && c!=' ')     //copy to ' ' or 0 => url
 {
  http_str_addc(addr, c);
  c=((src->str)[t++]);
 }

 while(c!=0 && c==' '){c=((src->str)[t++]);} //skip space

 if(c!=0)
 {
  while(c!=0 && c!=' ')    //copy to ' ' or 0 => version
  {
   http_str_addc(ver, c);
   c=((src->str)[t++]);
  }
 }

 //splitting the url (http://user:pass@www.srv.com:port/dir/file.html) => http:// (user:pass) @ (www.srv.com:port) (/dir/file.html)

 ta=http_str_ncmpis(addr, "HTTP://", 7) | http_str_ncmpis(addr, "HTTPS://", 8); //"http://" or "https://"
 tb=http_str_contains_c(addr, '@');
 if(ta==FALSE && tb==-1)
 {
  //do nothing (no (http://) and no (user:pass)
 }else{
  if(ta==TRUE) //cut (http://) => url
  {
   addrflg=TRUE;
   if(http_str_ncmpis(addr, "HTTP://", 7)==TRUE)
    http_str_sets(url, ((addr->str)+7));
   else 
    http_str_sets(url, ((addr->str)+8));
  }else{
   http_str_set(url, addr);
  }
  if(tb!=-1) //cut (user:pass) => userpass & => addr
  {
   tb=http_str_contains_c(url, '@');
   http_str_copyn(userpass, url, tb);
   http_str_sets(addr, ((url->str)+tb+1));   //+1: skip '@'
  }else{
   http_str_set(addr, url);
  }
 }
 //state: userpass=user:pass addr=www.srv.com:port/dir/file.htm

 if(addrflg==TRUE)                         //url has address part
 {
  t=http_str_contains_c(addr, '/');        //the 1st '/'
  if(t==-1) t=addr->len;
  http_str_sets(url, ((addr->str)+t));     //copy (/dir/file.html) => url
  http_str_truncate(addr,t);               //cut (www.srv.com:port)
 }else{
  http_str_set(url, addr);
  http_str_sets(addr, "");
 }
 //state: userpass=user:pass addr=www.srv.com:port url=/dir/file.htm ver=http/1.0 

 return(TRUE);
}

int http_splitresp(HttpStr* src, HttpStr* ver, HttpStr* idnum, HttpStr* resp)
{
 int t=0;
 int c;

 http_str_sets(ver,""); http_str_sets(idnum,""); http_str_sets(resp,"");

 if(src->len==0) return(FALSE);
// if(http_check(src)==FALSE) return(FALSE);

 c=(src->str)[0];
 while(c!=0 && c==' '){c=((src->str)[t++]);} //skip space
 if(c==0) return(FALSE);   //empty...
 
 //if(strncasecmp((src->str)+t, "HTTP/", 5)==TRUE) // HTTP/1.0 | HTTP/1.1
 //{
 c=((src->str)[t++]);
 while(c!=0 && c!=' ')     //copy to ' ' or 0 => ver
 {
  http_str_addc(ver, c);
  c=((src->str)[t++]);
 }
 //}
 if(c==0) return(FALSE);   //no idnum...

 while(c!=0 && c==' '){c=((src->str)[t++]);} //skip space
 if(c==0) return(FALSE);   //no idnum...

 while(c!=0 && c!=' ')     //copy to ' ' or 0 => idnum
 {
  http_str_addc(idnum, c);
  c=((src->str)[t++]);
 }

 while(c!=0 && c==' '){c=((src->str)[t++]);} //skip space

 if(c!=0)
 {
  while(c!=0)    //copy to ' ' or 0 => resp
  {
   http_str_addc(resp, c);
   c=((src->str)[t++]);
  }
 }

 return(TRUE);
}

int http_lookup_cmpis(char* a, char* b)  //terminators:  a= 0, '\n', '\r', ' ', ':'  b= 0, '\n', '\r'
{
 int t=0;
 while(a[t]!=0 && a[t]!='\n' && a[t]!='\r' && a[t]!=' ' &&
       b[t]!=0 && b[t]!='\n' && b[t]!='\r')
 {
  if(http_str_ucase(a[t])!=http_str_ucase(b[t])) return(FALSE);
  t++;
 }
 if((a[t]==0 || a[t]=='\n' || a[t]=='\r' || a[t]==' ' || a[t]==':') && (b[t]==0 || b[t]=='\n' || b[t]=='\r')) return(TRUE);
 return(FALSE);
}

int http_lookup(HttpStr* src, char* what, HttpStr* result, int valueonly)
{
 int t=0;

 http_str_sets(result, "");
 while((src->str)[t]!=0 && (src->str)[t]!='\n') t++; //skip cmd
 if((src->str)[t]==0) return(FALSE);
 t++;
 
 while((src->str)[t]!=0)
 {
  if(http_lookup_cmpis((src->str)+t, what)==TRUE)
  {
   if(valueonly==FALSE)
   {                                                                                       //copy to ':' or ' ' or end
    while((src->str)[t]!=0 && (src->str)[t]!='\n'  && (src->str)[t]!=' ' && (src->str)[t]!=':'){http_str_addc(result, (src->str)[t++]);} //copy to end
    http_str_addc(result, ':');
   }
   while((src->str)[t]!=0  && (src->str)[t]!='\n'  && (src->str)[t]!=':') t++;              //skip to ':' or end
   if((src->str)[t]==':') t++;
   while(((src->str)[t]!=0 && (src->str)[t]!='\n') && (src->str)[t]==' ') t++;              //skip whitespace
   while((src->str)[t]!=0  && (src->str)[t]!='\n'){http_str_addc(result, (src->str)[t++]);} //copy to end
   return(TRUE);
  }else
  {
   while((src->str)[t]!=0  && (src->str)[t]!='\n') t++; //skip entry
   if((src->str)[t]==0) return(FALSE);
   t++;
  }
 }
 return(FALSE);
}
