############################################################################
##
## Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
##
## $Id: Connector.py,v 1.9 2000/10/10 18:25:59 bazsi Exp $
##
## Author  : Bazsi
## Auditor : kisza
## Last version: 1.7
## Notes:
##
## Author  : Bazsi
## Auditor : kisza
## Last version: 1.7
## Notes:
##
############################################################################

from Zorp import *
import Zorp
import threading

class Connect:
	"""
		A wrapper class for the C object Zorp.Connect,
		which actually establishes a connection
		Attributes:
			local		Address of local end of the connection
			remote		Address where we connect
			connect		a Zorp.Connect object
	"""
	local = None
	remote = None

	def __init__(self, local, remote, callback = None):
		"""
			Creates an instance
			Parameters:
				local		Address of local end of the connection
				remote		Address where we connect
				callback	Callback to be called when the connection is established
			Workings:
				Sets the attributes
				If there is a callback, it establishes the connection
				and sets connect to be the Zorp.Connect object
			Return value:
				-
		"""
		self.local = local
		self.remote = remote
		if callback != None:
			self.connect = Zorp.Connect(local, remote, callback)
			
	def blockingConnect(self):
		"""
			Blocking connection establishment
			Parameters:
				-
			Workings:
				Establishes the connection and returns the fd of it
			Return value:
				The fd
				
		"""
		return Zorp.Connect(self.local, self.remote, None)
		
	def destroy(self):
		"""
			Destructor
			Parameters:
				-
			Workings:
				Calls the destroy method of the Zorp.Connect object
			Return value:
				-
		"""
		self.connect.destroy()
