############################################################################
##
## Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
##
## $Id: Http.py,v 1.6 2000/10/10 18:25:59 bazsi Exp $
##
## Author  : VPS
## Auditor : 
## Last version:
## Notes:
##
## Author  : VPS
## Auditor : 
## Last version:
## Notes:
##
############################################################################

from Zorp import *
import Service, Connector, Proxy, Session, Stream

MODE_CLOSE     = 1
MODE_KEEPALIVE = 2

FILTER_PASS          = 1
FILTER_DROP          = 2
FILTER_CHANGE_BOTH   = 3
FILTER_CHANGE_NAME   = 4
FILTER_CHANGE_VALUE  = 5
FILTER_CHANGE_REGEXP = 6 # TODO
FILTER_INSERT        = 7 # TODO
FILTER_POLICY        = 8

LOG_ERR0 = 128 #bitmapped
LOG_ERR1 = 64
LOG_ERR2 = 32
LOG_ERR3 = 16
LOG_EVN0 = 8
LOG_EVN1 = 4
LOG_EVN2 = 2
LOG_EVN3 = 1              

class HttpProxy(Proxy.Proxy):
	"""
		Wrapper class for the http proxy
	"""

	def __init__(self, session):
		"""
			Constructor
			Parameters:
				session		the session
			Workings:
				creates a Proxy instance using the http C code
			Return value:
				-
		"""
		Proxy.Proxy.__init__(self, "http", session)

#
# This proxy can be used as a transparent HTTP gateway.
#
class HttpProxyTransparent(HttpProxy):
	"""
		Transparent http proxy
	"""

	def config(self):
		"""
			config method
			Parameters:
				-
			Workings:
				sets transparent mode and 
				no request reformatting
		"""
		self.transparent_mode = 1
		self.server_address_transparent = 1

#
# This class can be used to grab a HTTP stream and redirect it to 
# a caching proxy on the outer network.
#
class HttpProxyRedirect(HttpProxy):
	"""
		Directed http proxy. It can be used to grab a HTTP stream and redirect it to
		a caching proxy on the outer network.
	"""
	def config(self):
		"""
			config method
			Parameters:
				-
			Workings:
				sets that the request should be converted
				to proxy request
		"""
		self.convert_to_proxy_request = 1
