############################################################################
##
## Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
##
## $Id: Receiver.py,v 1.5 2000/10/10 18:25:59 bazsi Exp $
##
## Author  : Bazsi
## Auditor : kisza
## Last version: 1.3
## Notes:
##
## Author  : Bazsi
## Auditor : kisza
## Last version: 1.3
## Notes:
##
############################################################################

from Zorp import *
import Zorp, Session, Service

class Receive:
	"""
		Base class for datagram listeners to be used with datagram
		oriented proxies.
		Wrapper for the low-level Receiver class
		attributes:
		listen		the low-level receiver object
		service		the service to start
		session		the session data
	"""
	listen = 0
	service = None

	def __init__(self, bindto, service):
		"""
			constructor
			Parameters:
				bindto	the address to bind to
				service	the service to start for incoming datagrams
			Workings:
				initialises the attributes, creates the receiver and the session,
				sets the file descriptor, and starts the service
			Return value:
				-
			FIXME:	from 0.7 we get the session, does not create it
		"""
		self.service = service
	        self.listen = Zorp.Receive(bindto)
		session = Session.MasterSession()
		session.client_fd = self.listen.getFD()
		self.service.startInstance(session)

	def destroy(self):
		"""
			destroys the receiver
			Parameters:
				-
			Workings:
				calls the destroy method of teh low-level object
			Return value:
				-
		"""
		self.listen.destroy()
