############################################################################
##
## Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
##
## $Id: SockAddr.py,v 1.8 2000/10/10 18:25:59 bazsi Exp $
##
## Author  : Bazsi
## Auditor : kisza
## Last version: 1.6
## Notes:
##   - comments in English
##
## Author  : Bazsi
## Auditor : kisza
## Last version: 1.6
## Notes:
##   - comments in English
##
############################################################################

from string import split, atoi

def inet_aton(ip):
	"""
		Internetcmbl csinl egy 32 bites egszt.
      
		Paramterek:
			ip			A konvertland ip, 3 ponttal elvlasztva

		Lers:
			Elsszr a kapott ip cmet sztbontja a ngy, ponttal elvlasztott
			rszre, majd a kapott 4 sztringet megprblja szmm alaktani, majd
			ezeket shiftelssel egymasba rakni. Figyelem! Semmilyen ellenrzst
			nem vgez az ip cim helyessgt rinten!

		Visszatrsi rtk:
			unsigned long
		---
		Converts an internet address to a 32 bit integer
		Parameters:
			ip		A dotted-quad string
		Workings:
			splits on the dot, atoi the parts, and bitshift the whole thing into one
			WARNING!	There is no parameter check!
		Return value:
			unsigned long
	"""
	parts=split(ip,'.', 4);
	return  atoi(parts[0]) << 24 | \
		atoi(parts[1]) << 16 | \
		atoi(parts[2]) << 8  | \
		atoi(parts[3])

def inet_ntoa(ip):
	"""
		A megadott 32 bites szmot visszaalakitja IP cimm

		Paramterek:
			ip			Az IP-v konvertlando 32 bites szm

		Lers:
			A kapott szmot bitmveletekkel rszekre osztja, ezeket vegl
			stringbe alaktja.

		Viszatrsi rtk:
			string
		---
		Converts a 32 bit integer into IP number('s string representation)
		Parameters:
			ip		The ip number in 32 bit integer
		Workings:
			splits into parts using bit arithmetis, and converts them into string
		Return value:
			string
	"""
	parts = ((ip & 0xff000000) >> 24,
		 (ip & 0x00ff0000) >> 16,
		 (ip & 0x0000ff00) >> 8,
		 (ip & 0x000000ff))
	return "%d.%d.%d.%d" % parts

#
#class SockAddr:
#	type = ""
#
#	def __init__(self, type):
#		self.type = type
#	def format(self):
#		raise NotImplementedError	
#
#	def __cmp__(self, other):
#		return -1
#
#class SockAddrInet(SockAddr):
#	ip = 0
#	ip_s = ""
#	port = 0
#	
#	def __init__(self, ip, port):
#		SockAddr.__init__(self, 'inet')
#		self.ip = inet_aton(ip)
#		self.ip_s = ip
#		self.port = port
#
#	def format(self):
#		return "AF_INET(%s:%d)" % (self.ip_s, self.port)
#
#	def __cmp__(self, other):
#		try:
#			if (other.type == self.type and other.ip == self.ip and other.port == self.port):
#				return 0
#		except:
#			return -1
#
#class SockAddrInet6(SockAddr):
#	def __init__(self, ip, port):
#		SockAddr.__init__(self, 'inet6')
#		self.ip = ip
#		self.port = port
#
#class SockAddrUnix(SockAddr):
#	def __init__(self, path):
#		SockAddr.__init__(self, 'unix')
#		self.path = path
#
#	def format(self):
###		return "AF_UNIX(%s)" % (self.path, )
