############################################################################
##
## Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
##
## $Id: Zorp.py,v 1.11 2000/10/10 18:25:59 bazsi Exp $
##
## Author  : Bazsi
## Auditor : kisza
## Last version: 1.8
## Notes:
##   - comments in English
##
## Author  : Bazsi
## Auditor : kisza
## Last version: 1.8
## Notes:
##   - comments in English
##
############################################################################

zones = []
services = []
listeners = []

firewall_name = "zorp" # should be unique, proposed name format: zorp@domain

settings = {}          # configuration is stored in this hash


# return values returned by event handlers
Z_UNSPEC	 = 0
Z_ACCEPT	 = 1
Z_DENY		 = 2
Z_REJECT	 = 3

Z_ERROR		 = 4
Z_CRITICAL 	 = 8
Z_WARNING 	 = 16
Z_MESSAGE 	 = 32
Z_INFO 		 = 64
Z_DEBUG          = 128

ZoneException = "Zone not found"
DACException = "DAC policy violation"
MACException = "MAC policy violation"
AuthException = "Authenticated failed"
InternalError = "Internal error occured"


def findZone(addr, interface = None):
	"""
		FIXME: OBSOLETE
		Megkeresi, hogy a csomagnak van-e znja

		Paramterek:
			addr			A csomag lersa
			interface	A csomag interface-e.

		Lers:
			Vgigfut a zones tmb elemein, s megnzi, hogy az ott trolt
			znba illik-e a csomag. Ha igen, akkor visszaadja azt a znt,
			ha nem, akkor kiir egy hibazenetet, hogy nem tallt megfel znt.

		Visszatrsi rtk:
			class zone
	"""
	i = 0
        while (i < len(zones)):
        	if (zones[i].isMember(addr, interface)):
                	return zones[i]
		i=i+1
	raise ZoneException, "Zone for %s(%s) not found." % (addr.format(), interface)

def error(level, msg):
	"""
		Error message
		Parameters:
			level	log level
			msg	message
		Workings:
			logs the message
		Return value:
			-
	"""
	log(level, Z_WARNING, msg)

def message(level, msg):
	"""
		informational message
		Parameters:
			level	log level
			msg	message
		Workings:
			logs the message
		Return value:
			-
	"""
	log(level, Z_MESSAGE, msg)

def debug(level, msg):
	"""
		debug message
		Parameters:
			level	log level
			msg	message
		Workings:
			logs the message
		Return value:
			-
	"""
	log(level, Z_DEBUG, msg)
